/*
 *  Copyright (C) 2012-2015  Thadeu Lima de Souza Cascardo <cascardo@minaslivre.org>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#ifndef _LIST_H
#define _LIST_H

typedef void (free_function_t)(void *);
typedef int (sort_function_t)(void *, void *);
struct list;

struct list * list_new(void);
int list_add(struct list **list, void *val);
int list_insert(struct list **list, int pos, void *val);
int list_insert_ordered(struct list **list, void *val, sort_function_t *fn);
void * list_get(struct list *list, int pos);
void list_free(struct list *list, free_function_t *ifree);

#endif
